<?php

add_action("widgets_init", "load_suffusion_widgets");

function load_suffusion_widgets() {
	register_widget("Suffusion_Search");
	register_widget("Suffusion_Text");
	register_widget("Suffusion_Meta");
}

class Suffusion_Search extends WP_Widget {
	function Suffusion_Search() {
		$widget_options = array(
			"classname" => "search",
			"description" => __("A search form for your blog", "suf_theme"),
		);

		$control_options = array(
			"id_base" => "search"
		);

		$this->WP_Widget("search", __("Search", "suf_theme"), $widget_options, $control_options);
	}

	function widget($args, $instance) {
		extract($args);

		$title = apply_filters("widget_title", $instance["title"]);
		echo $before_widget;
		if (trim($before_title) != "" || trim($after_title) != "") {
			echo $before_title.$title.$after_title;
		}
		include (TEMPLATEPATH . '/searchform.php');
		echo $after_widget;
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance["title"] = strip_tags($new_instance["title"]);

		return $instance;
	}

	function form($instance) {
		$defaults = array("title" => __("Search", "suf_theme"));
		$instance = wp_parse_args((array)$instance, $defaults);
?>

		<!-- Widget Title: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'suf_theme'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>

<?php
	}
}

/* The WP_Widget_Text class needed to be overridden because of empty titles. 
 * With Docking Boxes the "before_title" and "after_title" were not being invoked in case of empty titles, wrecking the layout. Only the "widget" function is overloaded
 */
class Suffusion_Text extends WP_Widget_Text {
	function Suffusion_Text() {
		$widget_ops = array('classname' => 'widget_text', 'description' => __('Arbitrary text or HTML', 'suf_theme'));
		$control_ops = array('width' => 400, 'height' => 350);
		$this->WP_Widget('text', __('Text', 'suf_theme'), $widget_ops, $control_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '' : $instance['title']);
		$text = apply_filters( 'widget_text', $instance['text'] );
		if ( !empty( $title ) ) { 
			echo $before_widget;
			echo $before_title . $title . $after_title; 
?>
			<div class="textwidget"><?php echo $instance['filter'] ? wpautop($text) : $text; ?></div>
<?php
			echo $after_widget;
		}
		else {
?>
			<div class="textwidget suf-horizontal-widget"><?php echo $instance['filter'] ? wpautop($text) : $text; ?></div>
<?php
		}
	}
}

class Suffusion_Meta extends WP_Widget_Meta {
	function Suffusion_Meta() {
		$widget_ops = array('classname' => 'widget_meta', 'description' => __( "Log in/out, admin, feed and WordPress links", "suf_theme") );
		$this->WP_Widget('meta', __('Meta', 'suf_theme'), $widget_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? __('Meta', 'suf_theme') : $instance['title']);

		echo $before_widget;
		if ( $title )
			echo $before_title . $title . $after_title;
?>
			<ul>
			<?php wp_register(); ?>
			<li><?php wp_loginout(); ?></li>
			<li class="rss"><a href="<?php bloginfo('rss2_url'); ?>" title="<?php echo esc_attr(__('Syndicate this site using RSS 2.0', 'suf_theme')); ?>"><?php _e('Entries <abbr title="Really Simple Syndication">RSS</abbr>', 'suf_theme'); ?></a></li>
			<li class="rss"><a href="<?php bloginfo('comments_rss2_url'); ?>" title="<?php echo esc_attr(__('The latest comments to all posts in RSS', 'suf_theme')); ?>"><?php _e('Comments <abbr title="Really Simple Syndication">RSS</abbr>', 'suf_theme'); ?></a></li>
			<?php wp_meta(); ?>
			</ul>
<?php
		echo $after_widget;
	}
}
?>
